'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _expr = require('../../../expr');

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Action = function Action() {
    _classCallCheck(this, Action);
};

var TodoAddMultipleAction = (function (_Action) {
    _inherits(TodoAddMultipleAction, _Action);

    function TodoAddMultipleAction() {
        _classCallCheck(this, TodoAddMultipleAction);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(TodoAddMultipleAction).apply(this, arguments));
    }

    return TodoAddMultipleAction;
})(Action);

var TodoAddMultipleErrorAction = (function (_Action2) {
    _inherits(TodoAddMultipleErrorAction, _Action2);

    function TodoAddMultipleErrorAction() {
        _classCallCheck(this, TodoAddMultipleErrorAction);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(TodoAddMultipleErrorAction).apply(this, arguments));
    }

    return TodoAddMultipleErrorAction;
})(Action);

var TodoAddErrorAction = (function (_Action3) {
    _inherits(TodoAddErrorAction, _Action3);

    function TodoAddErrorAction() {
        _classCallCheck(this, TodoAddErrorAction);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(TodoAddErrorAction).apply(this, arguments));
    }

    return TodoAddErrorAction;
})(Action);

var TodoCompleteErrorAction = (function (_Action4) {
    _inherits(TodoCompleteErrorAction, _Action4);

    function TodoCompleteErrorAction() {
        _classCallCheck(this, TodoCompleteErrorAction);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(TodoCompleteErrorAction).apply(this, arguments));
    }

    return TodoCompleteErrorAction;
})(Action);

var TodoDestroyErrorAction = (function (_Action5) {
    _inherits(TodoDestroyErrorAction, _Action5);

    function TodoDestroyErrorAction() {
        _classCallCheck(this, TodoDestroyErrorAction);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(TodoDestroyErrorAction).apply(this, arguments));
    }

    return TodoDestroyErrorAction;
})(Action);

var A = function A() {
    _classCallCheck(this, A);
};

var B = function B() {
    _classCallCheck(this, B);
};

var Reducer1 = {
    reduce: function reduce(a, action, b) {
        (0, _expr.babelPatternMatch)(action);
        return a;
    },
    addMultiple: function addMultiple(a, action, b) {
        return a;
    },
    addError: function addError(a, _ref, b) {
        var error = _ref.error;

        return a;
    }
};

var Reducer2 = (function () {
    function Reducer2() {
        _classCallCheck(this, Reducer2);
    }

    _createClass(Reducer2, null, [{
        key: 'reduce',
        value: function reduce(a, action, b) {
            (0, _expr.babelPatternMatch)(action);
            return a;
        }
    }, {
        key: 'addMultiple',
        value: function addMultiple(a, action, b) {
            return a;
        }
    }]);

    return Reducer2;
})();

var Reducer3 = (function () {
    function Reducer3() {
        _classCallCheck(this, Reducer3);
    }

    _createClass(Reducer3, [{
        key: 'reduce',
        value: function reduce(a, action, b) {
            (0, _expr.babelPatternMatch)(action);
            return a;
        }
    }, {
        key: 'addMultiple',
        value: function addMultiple(a, action, b) {
            return a;
        }
    }]);

    return Reducer3;
})();
/*
function reducer4(a: A, action: AnyAction, b: B): A {
    babelPatternMatch(action, {
        addMultiple(a: A, action: TodoAddMultipleAction, b: B): A {
            return a
        }
    })
    return a
}
*/

var reducer3 = new Reducer3();
exports.default = {
    reducer1: Reducer1.reduce,
    reducer2: Reducer2.reduce,
    reducer3: reducer3.reduce.bind(reducer3)
    //    reducer4: reducer4
};
//# sourceMappingURL=ExampleReducer.js.map